/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package interfacegrafica;

import static imagem.Imagem.verificaImagem;
import imagem.ImagemPgm;
import imagem.ImagemPpm;
import java.awt.Image;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author hugo
 */
public class JanelaPpm extends javax.swing.JFrame {
    private ImagemPpm ppm;

    public ImagemPpm getImagemPpm () {
       return ppm;
   }
   public void setImagemPpm (ImagemPpm ppm) {
       this.ppm = ppm;    
   }
   
   //Contrutor
    public JanelaPpm(ImagemPpm ppm) throws IOException {
        initComponents();
        setImagemPpm(ppm);
        
        try {
         ppm.abrirArquivo();
       } catch (FileNotFoundException ex) {
           Logger.getLogger(JanelaPgm.class.getName()).log(Level.SEVERE, null, ex);
       }
        //ppm.lerLinhasCabecalho();
        ppm.pegaDados(ppm.lerLinhasCabecalho());
              
        lblEndereco.setText(ppm.getEnderecoArquivo());
        
        
       try {
           lblImagem.setIcon(new ImageIcon(ppm.pegaPixels().getScaledInstance(520, 480, Image.SCALE_REPLICATE)));
       } catch (IOException ex) {
           Logger.getLogger(JanelaPgm.class.getName()).log(Level.SEVERE, null, ex);
       }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnGrupo = new javax.swing.ButtonGroup();
        btnAbrir = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        lblEndereco = new javax.swing.JLabel();
        rbtnNegativo = new javax.swing.JRadioButton();
        rbtnVermelho = new javax.swing.JRadioButton();
        rbtnVerde = new javax.swing.JRadioButton();
        rbtnAzul = new javax.swing.JRadioButton();
        btnAtivaFiltro = new javax.swing.JButton();
        lblImagem = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Imagem PPM");
        setResizable(false);

        btnAbrir.setText("Abrir");
        btnAbrir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAbrirActionPerformed(evt);
            }
        });

        jLabel1.setText("Local do Arquivo:");
        jLabel1.setBorder(new javax.swing.border.MatteBorder(null));

        lblEndereco.setBorder(new javax.swing.border.MatteBorder(null));

        btnGrupo.add(rbtnNegativo);
        rbtnNegativo.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        rbtnNegativo.setText("Filtro Negativo");
        rbtnNegativo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtnNegativoActionPerformed(evt);
            }
        });

        btnGrupo.add(rbtnVermelho);
        rbtnVermelho.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        rbtnVermelho.setText("Filtro Vermelho");
        rbtnVermelho.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtnVermelhoActionPerformed(evt);
            }
        });

        btnGrupo.add(rbtnVerde);
        rbtnVerde.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        rbtnVerde.setText("Filtro Verde");
        rbtnVerde.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtnVerdeActionPerformed(evt);
            }
        });

        btnGrupo.add(rbtnAzul);
        rbtnAzul.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        rbtnAzul.setText("Filtro Azul");
        rbtnAzul.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtnAzulActionPerformed(evt);
            }
        });

        btnAtivaFiltro.setFont(new java.awt.Font("Dialog", 1, 16)); // NOI18N
        btnAtivaFiltro.setText("Ativar");
        btnAtivaFiltro.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAtivaFiltroActionPerformed(evt);
            }
        });

        lblImagem.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Imagem", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.TOP));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnAbrir, javax.swing.GroupLayout.PREFERRED_SIZE, 116, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(34, 34, 34)
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblEndereco, javax.swing.GroupLayout.PREFERRED_SIZE, 371, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(rbtnAzul)
                            .addComponent(rbtnNegativo)
                            .addComponent(rbtnVerde)
                            .addComponent(rbtnVermelho)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(19, 19, 19)
                                .addComponent(btnAtivaFiltro, javax.swing.GroupLayout.PREFERRED_SIZE, 122, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 114, Short.MAX_VALUE)
                        .addComponent(lblImagem, javax.swing.GroupLayout.PREFERRED_SIZE, 530, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(149, 149, 149))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(btnAbrir, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(9, 9, 9)
                        .addComponent(lblEndereco, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 9, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(67, 67, 67)
                        .addComponent(rbtnNegativo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(rbtnVermelho)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(rbtnVerde)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(rbtnAzul)
                        .addGap(81, 81, 81)
                        .addComponent(btnAtivaFiltro, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(lblImagem, javax.swing.GroupLayout.PREFERRED_SIZE, 490, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(18, 18, 18))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnAbrirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAbrirActionPerformed
        JFileChooser choose = new JFileChooser();
        choose.setFileFilter(new FileNameExtensionFilter(".ppm, .pgm", "ppm", "pgm"));
        choose.setAcceptAllFileFilterUsed(false);
        choose.showOpenDialog(this);

        try {
            File arquivo = choose.getSelectedFile();
            switch (verificaImagem(arquivo.getPath())) {
                case 1:
                    ImagemPgm pgmJanela = new ImagemPgm(arquivo.getPath());
                    JanelaPgm interfacePgm = new JanelaPgm(pgmJanela);
                    interfacePgm.setVisible(true);
                    dispose();
                    break;
                case 2:
                    ImagemPpm ppm = new ImagemPpm(arquivo.getPath());
                    JanelaPpm interfacePpm = new JanelaPpm(ppm);
                    interfacePpm.setVisible(true);
                    dispose();
                    break;
                default:
                    JOptionPane.showMessageDialog(null, "\nO tipo da imagem está incorreta.\nEscolha uma imagem válida.", "Arquivo inválido!", JOptionPane.ERROR_MESSAGE);
                    break;
            }
        } catch (NullPointerException npE) {
        } catch (IOException ex) {
            Logger.getLogger(PrimeiraTela.class.getName()).log(Level.SEVERE, null, ex);
        
        
    }    }//GEN-LAST:event_btnAbrirActionPerformed

    private void btnAtivaFiltroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAtivaFiltroActionPerformed
        String opcao = btnGrupo.getSelection().getActionCommand();
        
        if (opcao.equals("Filtro Negativo")) {
            try {
                lblImagem.setIcon(new ImageIcon(getImagemPpm().filtroNegativo().getScaledInstance(520, 480, Image.SCALE_REPLICATE)));
            } catch (IOException ex) {
                Logger.getLogger(JanelaPgm.class.getName()).log(Level.SEVERE, null, ex);
            }

        }
        else if (opcao.equals("Filtro Vermelho")) { 
            try {           
                lblImagem.setIcon(new ImageIcon(getImagemPpm().filtroRed().getScaledInstance(520, 480, Image.SCALE_REPLICATE)));
            } catch (IOException ex) {
                Logger.getLogger(JanelaPgm.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        else if (opcao.equals("Filtro Verde")) {
            try {            
                lblImagem.setIcon(new ImageIcon(getImagemPpm().filtroGreen().getScaledInstance(520, 480, Image.SCALE_REPLICATE)));
            } catch (IOException ex) {
                Logger.getLogger(JanelaPgm.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        else if (opcao.equals("Filtro azul")) {
            try {            
                lblImagem.setIcon(new ImageIcon(getImagemPpm().filtroBlue().getScaledInstance(520, 480, Image.SCALE_REPLICATE)));
            } catch (IOException ex) {
                Logger.getLogger(JanelaPgm.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        else if (opcao.equals("Original")) {
            try {
                setImagemPpm(new ImagemPpm(getImagemPpm().getEnderecoArquivo()));
                lblImagem.setIcon(new ImageIcon(getImagemPpm().pegaPixels().getScaledInstance(520, 480, Image.SCALE_REPLICATE)));
            } catch (IOException ex) {
                Logger.getLogger(JanelaPgm.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }//GEN-LAST:event_btnAtivaFiltroActionPerformed

    private void rbtnNegativoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtnNegativoActionPerformed
        rbtnNegativo.setActionCommand("Filtro Negativo");
    }//GEN-LAST:event_rbtnNegativoActionPerformed

    private void rbtnVermelhoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtnVermelhoActionPerformed
        rbtnVermelho.setActionCommand("Filtro Vermelho");    }//GEN-LAST:event_rbtnVermelhoActionPerformed

    private void rbtnVerdeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtnVerdeActionPerformed
        rbtnVerde.setActionCommand("Filtro Verde");    }//GEN-LAST:event_rbtnVerdeActionPerformed

    private void rbtnAzulActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtnAzulActionPerformed
        rbtnAzul.setActionCommand("Filtro azul");                                            
    }//GEN-LAST:event_rbtnAzulActionPerformed

    /**
     * @param args the command line arguments
     */
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAbrir;
    private javax.swing.JButton btnAtivaFiltro;
    private javax.swing.ButtonGroup btnGrupo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel lblEndereco;
    private javax.swing.JLabel lblImagem;
    private javax.swing.JRadioButton rbtnAzul;
    private javax.swing.JRadioButton rbtnNegativo;
    private javax.swing.JRadioButton rbtnVerde;
    private javax.swing.JRadioButton rbtnVermelho;
    // End of variables declaration//GEN-END:variables
}
